export type DeepPartial<T> = T extends Function ? T : T extends object ? {
    [P in keyof T]?: DeepPartial<T[P]>;
} : T;
export type NonMutable<T extends object> = {
    [Key in keyof Omit<T, 'mutate'>]: T[Key] extends object ? NonMutable<Exclude<T[Key], Function>> | Extract<T[Key], Function> : T[Key];
};
export type Mutable<T extends object = any, K = any> = {
    [Key in keyof T]: T[Key] extends object ? Mutable<Exclude<T[Key], Function>, K> | Extract<T[Key], Function> : T[Key];
} & {
    mutate?: {
        [key: string]: DeepPartial<Mutated<T, K>> | ((this: K, obj: T, ...args: any) => DeepPartial<T>);
    };
};
export type Mutated<T extends object, K = any> = {
    [Key in keyof T]: T[Key] extends object ? Mutated<Exclude<T[Key], Function>> | Extract<T[Key], Function> : T[Key] | symbol;
} | symbol;
export type MutableCondition = string | {
    condition: string;
    args?: () => any | any[];
};
export declare const deleteValue: unique symbol;
export declare function applyMutation<T extends Mutable<T>>(conditions: MutableCondition[], obj: T, option?: {
    keepMutation?: boolean;
    top?: boolean;
}): any;
